blob: c31fefe3339df4ef7fdfa2b7adfa843390f1233e [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
20while [ -h "${prog}" ]; do
21 newProg=`/bin/ls -ld "${prog}"`
22 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
23 if expr "x${newProg}" : 'x/' >/dev/null; then
24 prog="${newProg}"
25 else
26 progdir=`dirname "${prog}"`
27 prog="${progdir}/${newProg}"
28 fi
29done
30oldwd=`pwd`
31progdir=`dirname "${prog}"`
32cd "${progdir}"
33progdir=`pwd`
34prog="${progdir}"/`basename "${prog}"`
35
36run_args=""
37usage="no"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +070038sequental="no"
jeffhao5d1ac922011-09-29 17:41:15 -070039
40while true; do
41 if [ "x$1" = "x--host" ]; then
42 run_args="${run_args} --host"
43 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -080044 elif [ "x$1" = "x--jvm" ]; then
45 run_args="${run_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -070046 shift
jeffhao5d1ac922011-09-29 17:41:15 -070047 elif [ "x$1" = "x--debug" ]; then
48 run_args="${run_args} --debug"
49 shift
50 elif [ "x$1" = "x--zygote" ]; then
51 run_args="${run_args} --zygote"
52 shift
jeffhao0dff3f42012-11-20 15:13:43 -080053 elif [ "x$1" = "x--interpreter" ]; then
54 run_args="${run_args} --interpreter"
55 shift
jeffhao5d1ac922011-09-29 17:41:15 -070056 elif [ "x$1" = "x--no-verify" ]; then
57 run_args="${run_args} --no-verify"
58 shift
59 elif [ "x$1" = "x--no-optimize" ]; then
60 run_args="${run_args} --no-optimize"
61 shift
62 elif [ "x$1" = "x--valgrind" ]; then
63 run_args="${run_args} --valgrind"
64 shift
65 elif [ "x$1" = "x--dev" ]; then
66 run_args="${run_args} --dev"
67 shift
68 elif [ "x$1" = "x--update" ]; then
69 run_args="${run_args} --update"
70 shift
71 elif [ "x$1" = "x--help" ]; then
72 usage="yes"
73 shift
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +070074 elif [ "x$1" = "x--seq" ]; then
75 sequental="yes"
76 shift
77 elif [ "x$1" = "x-O" ]; then
78 run_args="${run_args} -O"
79 shift
Zheng Xudc8e7322014-05-07 17:07:20 +010080 elif [ "x$1" = "x--64" ]; then
81 run_args="${run_args} --64"
82 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +020083 elif [ "x$1" = "x--trace" ]; then
84 run_args="${run_args} --trace"
85 shift
Alex Lighta59dd802014-07-02 16:28:08 -070086 elif [ "x$1" = "x--relocate" ]; then
87 run_args="${run_args} --relocate"
88 shift
89 elif [ "x$1" = "x--no-relocate" ]; then
90 run_args="${run_args} --no-relocate"
91 shift
92 elif [ "x$1" = "x--prebuild" ]; then
93 run_args="${run_args} --prebuild"
94 shift;
jeffhao5d1ac922011-09-29 17:41:15 -070095 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -070096 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -070097 usage="yes"
98 break
99 else
100 break
101 fi
102done
103
104if [ "$usage" = "yes" ]; then
105 prog=`basename $prog`
106 (
107 echo "usage:"
108 echo " $prog --help Print this message."
109 echo " $prog [options] Run all tests with the given options."
110 echo " Options are all passed to run-test; refer to that for " \
111 "further documentation:"
jeffhao0dff3f42012-11-20 15:13:43 -0800112 echo " --debug --dev --host --interpreter --jvm --no-optimize"
Alex Lighta59dd802014-07-02 16:28:08 -0700113 echo " --no-verify -O --update --valgrind --zygote --64 --relocate"
114 echo " --prebuild"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700115 echo " Specific Runtime Options:"
116 echo " --seq Run tests one-by-one, avoiding failures caused by busy CPU"
jeffhao5d1ac922011-09-29 17:41:15 -0700117 ) 1>&2
118 exit 1
119fi
120
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700121if [ "$sequental" == "yes" ]; then
122 i=0
123 for test_name in *; do
124 if [ -d "$test_name" -a -r "$test_name" -a -r "$test_name/info.txt" ]; then
125 ./run-test ${run_args} "$test_name"
126 RES=$?
127 test_pids[i]=i
128 test_names[test_pids[i]]="$test_name"
129 if [ "$RES" != "0" ]; then
130 let failure_count+=1
131 failed_test_names="$failed_test_names ${test_names[i]}"
132 else
133 let succeeded_count+=1
134 fi
135 let i+=1
136 fi
137 done
138else
139 # start all the tests
140 i=0
141 for test_name in *; do
142 if [ -d "$test_name" -a -r "$test_name" -a -r "$test_name/info.txt" ]; then
143 ./run-test ${run_args} "$test_name" &
144 test_pids[i]=$!
145 test_names[test_pids[i]]="$test_name"
146 let i+=1
147 fi
148 done
jeffhao5d1ac922011-09-29 17:41:15 -0700149
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700150 # wait for all the tests, collecting the failures
151 failure_count=0
152 succeeded_count=0
153 failed_test_names=""
154 for pid in ${test_pids[@]}; do
155 wait $pid
156 if [ "$?" != "0" ]; then
157 let failure_count+=1
158 failed_test_names="$failed_test_names ${test_names[$pid]}[pid=$pid]"
159 else
160 let succeeded_count+=1
161 fi
162 done
163fi
jeffhao5d1ac922011-09-29 17:41:15 -0700164
TDYa127b92bcab2012-04-08 00:09:51 -0700165echo "succeeded tests: $succeeded_count"
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700166echo "failed tests: $failure_count"
167
168for i in $failed_test_names; do
169 echo "failed: $i"
jeffhao5d1ac922011-09-29 17:41:15 -0700170done